//+------------------------------------------------------------------+
//|                                                        S-RoC.mq4 |
//|                                    Copyright (C) 2009 DragoTrade |
//|                        Licensed under GNU General Public License |
//+------------------------------------------------------------------+
//http://codebase.mql4.com/ru/5486
#property copyright "DragoTrade" 

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Yellow
//---- input parameters
extern int 
      ROC_Period     = 21,
      MA_Period      = 13,
      MA_Method      = 1,  // ????? ??????????: 0 - MODE_SMA, 1 - MODE_EMA, 2 - MODE_SMMA, 3 - MODE_LWMA
      Shift          = 0,  // ?????
      slnShift       = 2,  // ?????
      Price          = 0;  // ????: 0 - PRICE_CLOSE, 1 - PRICE_OPEN, 2 - PRICE_HIGH, 3 - PRICE_LOW,

extern int SigMaPeriod     = 5;
extern int SigMaMetod      = 1;  
extern int SigMaShift      = 2;  
                           //       4 - PRICE_MEDIAN, 5 - PRICE_TYPICAL, 6 - PRICE_WEIGHTED
//---- buffers
double b[];
double buffer2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,b);
   SetIndexShift(0,Shift);
   SetIndexBuffer(1,buffer2);
   SetIndexShift (1,SigMaShift);
//   SetLevelValue(0, 0);
   IndicatorShortName("S-RoC ("+ROC_Period+", MA "+MA_Period+") ");

   for(int b=0;b<=indicator_buffers;b++) SetIndexDrawBegin (b,ROC_Period+MA_Period+SigMaPeriod);


//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
            limit=Bars-counted_bars;

   for (i=limit; i>= 0; i--)
   {


   double t,curr,prev;
      curr=iMA(NULL,0,MA_Period,0,MA_Method,Price,i);
      prev=iMA(NULL,0,MA_Period,0,MA_Method,Price,i+ROC_Period);
      if(prev!=0)
      {
         t=(curr-prev)/prev;
      }
      b[i]=t;

   }
   for (i=limit; i>= 0; i--)
  buffer2[i]=iMAOnArray(b,0,SigMaPeriod,0,SigMaMetod,i);
  
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+